<?php

namespace App\Controller\Api;

use Cake\Event\Event;
use Cake\ORM\TableRegistry;
use Cake\Network\Email\Email;

/**
 * Occupations Controller
 *
 * @property \App\Model\Table\Occupations $Occupations
 */
class WebservicesController extends AppController {

    public function initialize() {
        parent::initialize();
        $this->loadModel('Preregisters');
        $this->loadModel('Options');
        $this->loadModel('Auctions');
        $this->loadModel('Locations');
        $this->loadModel('Amenities');
        $this->loadModel('ProjectImages');
        $this->loadModel('PosessionStatus');
        $this->Auth->allow(['token', 'auctions_preregister', 'home_slider', 'projects_list', 'forgot_password', 'property_list', 'property_detail']);
    }

    public function auctions_preregister() {
        $this->loadModel('Preregisters');
        $options = $this->Options->getOptions();
        $usertype = $this->request->data['usertype'];
        $name = $this->request->data['name'];
        $email_a = $this->request->data['email'];
        $mobile = $this->request->data['mobile'];
        $message = $this->request->data['message'];

        $email_message = "<table class='dataTable' cellpadding='0' cellspacing='0' style='background-color:#eaeaea;background-image:none;background-repeat:repeat;background-position:top left;background-attachment:scroll;border-width:1px;border-style:solid;border-color:#cdcdcd;width:100%;' >
                                                                    <tr><th style='padding-top:8px;padding-bottom:8px;padding-right:8px;padding-left:8px;font-size:12px;font-weight:bold;text-align:right;background-color:#d3d3d3;background-image:none;background-repeat:repeat;background-position:top left;background-attachment:scroll;border-bottom-width:1px;border-bottom-style:solid;border-bottom-color:#e4e4e4;' >Name:</th><td style='padding-top:8px;padding-bottom:8px;padding-right:8px;padding-left:8px;font-size:12px;color:#666;border-bottom-width:1px;border-bottom-style:solid;border-bottom-color:#cdcdcd;' >" . $name . "</tr>
                                                                    <tr><th style='padding-top:8px;padding-bottom:8px;padding-right:8px;padding-left:8px;font-size:12px;font-weight:bold;text-align:right;background-color:#d3d3d3;background-image:none;background-repeat:repeat;background-position:top left;background-attachment:scroll;border-bottom-width:1px;border-bottom-style:solid;border-bottom-color:#e4e4e4;' >Email:</th><td style='padding-top:8px;padding-bottom:8px;padding-right:8px;padding-left:8px;font-size:12px;color:#666;border-bottom-width:1px;border-bottom-style:solid;border-bottom-color:#cdcdcd;' >" . $email_a . "</tr>
                                                                    <tr><th style='padding-top:8px;padding-bottom:8px;padding-right:8px;padding-left:8px;font-size:12px;font-weight:bold;text-align:right;background-color:#d3d3d3;background-image:none;background-repeat:repeat;background-position:top left;background-attachment:scroll;border-bottom-width:1px;border-bottom-style:solid;border-bottom-color:#e4e4e4;' >Phone:</th><td style='padding-top:8px;padding-bottom:8px;padding-right:8px;padding-left:8px;font-size:12px;color:#666;border-bottom-width:1px;border-bottom-style:solid;border-bottom-color:#cdcdcd;' >" . $mobile . "</tr>";
        if (!empty($message)) {
            $email_message .= "<tr><th style='padding-top:8px;padding-bottom:8px;padding-right:8px;padding-left:8px;font-size:12px;font-weight:bold;text-align:right;background-color:#d3d3d3;background-image:none;background-repeat:repeat;background-position:top left;background-attachment:scroll;border-bottom-width:1px;border-bottom-style:solid;border-bottom-color:#e4e4e4;' >Message:</th><td style='padding-top:8px;padding-bottom:8px;padding-right:8px;padding-left:8px;font-size:12px;color:#666;border-bottom-width:1px;border-bottom-style:solid;border-bottom-color:#cdcdcd;' >" . $message . "</tr>";
        }
        $email_message .= "</table>";

        $final_message = $options['email_header'] . $email_message . $options['email_footer'];
        $final_message = htmlspecialchars_decode($final_message);

        $email = new Email('default');
        $email->from(['info@ownaroof.com' => 'Wholesale'])
                ->emailFormat('html')
                ->to($email_a)
                ->subject('Thanks for Pre-register as a ' . $usertype)
                ->send($final_message);

        $email->from(['info@ownaroof.com' => 'Wholesale'])
                ->emailFormat('html')
                ->to('support@ownaroof.com')
                ->addTo('leads@ownaroof.com')
                ->subject('A new user Pre-register as a ' . $usertype)
                ->send($final_message);

        $user = $this->Preregisters->newEntity([
            'usertype' => $usertype,
            'name' => $name,
            'email' => $email_a,
            'mobile' => $mobile,
            'message' => $message,
        ]);
        $user = $this->Preregisters->save($user);
        if (isset($user)) {
            $response["status"] = 1;
            $response["message"] = "User Added Successfully";
            $response["data"] = $user;
        } else {
            $response["status"] = 0;
            $response["message"] = "Error to add";
            $response["data"] = '';
        }
        $this->set('response', $response);
        $this->set('_serialize', ['response']);
    }

    public function token() {
        //pr($this->request->data);die;
        $user = $this->Auth->identify();
        if ($user) {
            $response["status"] = 1;
            $response["message"] = "User Details";
            $response["data"] = $user;
        } else {
            $response["status"] = 0;
            $response["message"] = "No Record found";
            $response["data"] = '';
        }
        $this->set('response', $response);
        $this->set('_serialize', ['response']);
    }

    public function forgot_password() {
        if (!isset($this->request->data['email'])) {
            $response["status"] = 0;
            $response["message"] = "Send Required Params";
            $response["data"] = '';
        } else {
            $email = $this->request->data['email'];
            $user = $this->Users->find('all')->where(['email' => $email])->first();
            if ($user) {
                $newPassword = rand();
                $this->request->data['password'] = $newPassword;
                $user = $this->Users->patchEntity($user, $this->request->data);
                //echo $newPassword;
                if ($this->Users->save($user)) {
                    $email = new Email('default');
                    $to = $user['email'];
                    $email->from(['info@ownaroof.com' => 'OwnAroof'])
                            ->to($to)
                            ->subject('New Password')
                            ->send('Your new password is:' . $newPassword);
                }
                $response["status"] = 1;
                $response["message"] = "User Details";
                $response["data"] = $user;
            } else {
                $response["status"] = 0;
                $response["message"] = "No Record found";
                $response["data"] = '';
            }
        }
        $this->set('response', $response);
        $this->set('_serialize', ['response']);
    }

    public function authuser($api_key = '') {
        $user = $this->Users->find('all')->where(['api_key' => $api_key])->first();
        if ($user) {
            return TRUE;
        } else {
            return FALSE;
        }
    }

    /**
     * Property Listing
     */
    public function property_list() {
        $auctionsData = $this->Auctions->find('All', ['fields' => ['id', 'title', 'area', 'bedroom', 'address', 'actualPrice', 'reservePrice', 'auctionDate', 'auctionEndDate'], 'conditions' => ['status' => 1]]);
        $auction = $auctionsData;
        if (isset($auction)) {
            $response["status"] = 1;
            $response["message"] = "Property Detail";
            $response["data"] = $auction;
        } else {
            $response["status"] = 0;
            $response["message"] = "Error to fetch data";
            $response["data"] = '';
        }
        $this->set('response', $response);
        $this->set('_serialize', ['response']);
    }

    /**
     * Property Detail
     * Body: property_id
     */
    public function property_detail() {
        $property_id = $this->request->data['property_id'];
        $auction = [];
        $auctionDetail = $this->Auctions->get($property_id);
        $locationDetail = $this->Locations->get($auctionDetail->location_id, ['fields' => 'name']);
        $posessionDetail = $this->PosessionStatus->get($auctionDetail->posession_id, ['fields' => 'title']);
        $imagesData = $this->ProjectImages->find('All', ['fields' => ['image']])->where(['project_id' => $auctionDetail->id]);
        $a_ids = explode(",", $auctionDetail->amenities);
        $amenitiesData = $this->Amenities->find('All', ['fields' => ['name', 'image']])->where(['id IN' => $a_ids]);
        $auction['details'] = $auctionDetail;
        $auction['location'] = $locationDetail;
        $auction['posession'] = $posessionDetail;
        $auction['images'] = $imagesData;
        $auction['amenities'] = $amenitiesData;
        $auction['gallary_img_url'] = WEBSITE_URL . 'webroot/uploads/auctions/';
        $auction['amenities_img_url'] = WEBSITE_URL . 'webroot/uploads/amenities/';
        $auction['near_by_projects'] = [['project_name' => 'Bhoomi Heights', 'builder' => 'Bhoomi Group', 'type' => 'Under Construction', 'distance' => '4.9 K.M.', 'price_range' => '2600 Rs. Per/SqFt.'], ['project_name' => 'Uma Aangan', 'builder' => 'Wish Empire', 'type' => 'Ready to Move', 'distance' => '7.3 K.M.', 'price_range' => '2400 Rs. Per/SqFt.'], ['project_name' => 'Vilasa Taruchaya', 'builder' => 'Vilasa', 'type' => 'Under Construction', 'distance' => '5.8 K.M.', 'price_range' => '3125 Rs. Per/SqFt.'], ['project_name' => 'Mahima Nirvana', 'builder' => 'Mahima Group', 'type' => 'Ready to Move', 'distance' => '6.8 K.M.', 'price_range' => '4115 Rs. Per/SqFt.'], ['project_name' => 'My Haveli', 'builder' => 'UDB Group', 'type' => 'Ready to Move', 'distance' => '8.6 K.M.', 'price_range' => '3010 Rs. Per/SqFt.']];
        $auction['price_trends'] = ['year' => ['2008', '2009', '2010', '2011', '2012', '2013', '2014', '2015', '2016'], 'price' => ['600', '1200', '1800', '2400', '3000'], 'result_points' => ['1869', '1950', '1953', '1920', '2112', '2408', '2580', '2735', '2696']];
        if (isset($auction)) {
            $response["status"] = 1;
            $response["message"] = "Property Detail";
            $response["data"] = $auction;
        } else {
            $response["status"] = 0;
            $response["message"] = "Error to fetch data";
            $response["data"] = '';
        }
        $this->set('response', $response);
        $this->set('_serialize', ['response']);
    }

}
